action.yml 7.2 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196
  1. # NOTE: Do not rely on `make` commands here as this action is used across different repos
  2. # where the Makefile will not be available
  3. name: 'Sentry Setup'
  4. description: 'Sets up a Sentry test environment'
  5. inputs:
  6. workdir:
  7. description: 'Directory where the sentry source is located'
  8. required: false
  9. default: '.'
  10. snuba:
  11. description: 'Is snuba required?'
  12. required: false
  13. default: 'false'
  14. clickhouse:
  15. description: 'Is clickhouse required?'
  16. required: false
  17. default: 'false'
  18. kafka:
  19. description: 'Is kafka required?'
  20. required: false
  21. default: 'false'
  22. chartcuterie:
  23. description: 'Is chartcuterie required?'
  24. required: false
  25. default: 'false'
  26. bigtable:
  27. description: 'Is bigtable required?'
  28. required: false
  29. default: 'false'
  30. redis_cluster:
  31. description: 'Is redis cluster required?'
  32. required: false
  33. default: 'false'
  34. symbolicator:
  35. description: 'Is symbolicator required?'
  36. required: false
  37. default: 'false'
  38. python-version:
  39. description: 'python version to install'
  40. required: false
  41. default: '3.11.8'
  42. pg-version:
  43. description: 'PostgreSQL version to use'
  44. default: '14'
  45. required: false
  46. outputs:
  47. yarn-cache-dir:
  48. description: 'Path to yarn cache'
  49. value: ${{ steps.config.outputs.yarn-cache-dir }}
  50. matrix-instance-number:
  51. description: 'The matrix instance number (starting at 1)'
  52. value: ${{ steps.config.outputs.matrix-instance-number }}
  53. matrix-instance-total:
  54. description: 'Reexport of MATRIX_INSTANCE_TOTAL.'
  55. value: ${{ steps.config.outputs.matrix-instance-total }}
  56. runs:
  57. using: 'composite'
  58. steps:
  59. - name: Setup default environment variables
  60. # the default for "bash" is:
  61. # bash --noprofile --norc -eo pipefail {0}
  62. shell: bash --noprofile --norc -eo pipefail -ux {0}
  63. env:
  64. MATRIX_INSTANCE: ${{ matrix.instance }}
  65. # XXX: We should be using something like len(strategy.matrix.instance) (not possible atm)
  66. # If you have other things like python-version: [foo, bar, baz] then the sharding logic
  67. # isn't right because job-total will be 3x larger and you'd never run 2/3 of the tests.
  68. # MATRIX_INSTANCE_TOTAL: ${{ strategy.job-total }}
  69. run: |
  70. echo "PIP_DISABLE_PIP_VERSION_CHECK=on" >> $GITHUB_ENV
  71. echo "PIP_INDEX_URL=https://pypi.devinfra.sentry.io/simple" >> $GITHUB_ENV
  72. echo "SENTRY_SKIP_BACKEND_VALIDATION=1" >> $GITHUB_ENV
  73. ### node configuration ###
  74. echo "NODE_ENV=development" >> $GITHUB_ENV
  75. ### pytest configuration ###
  76. echo "PY_COLORS=1" >> "$GITHUB_ENV"
  77. echo "PYTEST_ADDOPTS=--reruns=5 --durations=10 --fail-slow=60s" >> $GITHUB_ENV
  78. ### pytest-sentry configuration ###
  79. if [ "$GITHUB_REPOSITORY" = "getsentry/sentry" ]; then
  80. echo "PYTEST_SENTRY_DSN=https://6fd5cfea2d4d46b182ad214ac7810508@sentry.io/2423079" >> $GITHUB_ENV
  81. echo "PYTEST_SENTRY_TRACES_SAMPLE_RATE=0" >> $GITHUB_ENV
  82. # This records failures on master to sentry in order to detect flakey tests, as it's
  83. # expected that people have failing tests on their PRs
  84. if [ "$GITHUB_REF" = "refs/heads/master" ]; then
  85. echo "PYTEST_SENTRY_ALWAYS_REPORT=1" >> $GITHUB_ENV
  86. fi
  87. fi
  88. # Configure a different release version, otherwise it defaults to the
  89. # commit sha which will conflict with our actual prod releases. This is a
  90. # confusing experience because it looks like these are "empty" releases
  91. # because no commits are attached and associates the release with our
  92. # javascript + sentry projects.
  93. echo "SENTRY_RELEASE=ci@$GITHUB_SHA" >> $GITHUB_ENV
  94. # this handles pytest test sharding
  95. if [ "$MATRIX_INSTANCE" ]; then
  96. if ! [ "${MATRIX_INSTANCE_TOTAL:-}" ]; then
  97. echo "MATRIX_INSTANCE_TOTAL is required."
  98. exit 1
  99. fi
  100. echo "TEST_GROUP=$MATRIX_INSTANCE" >> $GITHUB_ENV
  101. echo "TOTAL_TEST_GROUPS=$MATRIX_INSTANCE_TOTAL" >> $GITHUB_ENV
  102. fi
  103. - uses: getsentry/action-setup-venv@a133e6fd5fa6abd3f590a1c106abda344f5df69f # v2.1.0
  104. with:
  105. python-version: ${{ inputs.python-version }}
  106. cache-dependency-path: ${{ inputs.workdir }}/requirements-dev-frozen.txt
  107. install-cmd: cd ${{ inputs.workdir }} && python3 -m tools.hack_pip && pip install -r requirements-dev-frozen.txt
  108. - name: Set up outputs
  109. id: config
  110. env:
  111. MATRIX_INSTANCE: ${{ matrix.instance }}
  112. shell: bash --noprofile --norc -eo pipefail -ux {0}
  113. run: |
  114. echo "yarn-cache-dir=$(yarn cache dir)" >> "$GITHUB_OUTPUT"
  115. echo "matrix-instance-number=$(($MATRIX_INSTANCE+1))" >> "$GITHUB_OUTPUT"
  116. echo "matrix-instance-total=$((${MATRIX_INSTANCE_TOTAL:-}))" >> "$GITHUB_OUTPUT"
  117. - name: Install python dependencies
  118. shell: bash --noprofile --norc -eo pipefail -ux {0}
  119. env:
  120. # This is necessary when other repositories (e.g. relay) want to take advantage of this workflow
  121. # without needing to fork it. The path needed is the one where setup.py is located
  122. WORKDIR: ${{ inputs.workdir }}
  123. run: |
  124. cd "$WORKDIR"
  125. # We need to install editable otherwise things like check migration will fail.
  126. python3 -m tools.fast_editable --path .
  127. - name: Start devservices
  128. shell: bash --noprofile --norc -eo pipefail -ux {0}
  129. env:
  130. NEED_KAFKA: ${{ inputs.kafka }}
  131. NEED_SNUBA: ${{ inputs.snuba }}
  132. NEED_CLICKHOUSE: ${{ inputs.clickhouse }}
  133. NEED_BIGTABLE: ${{ inputs.bigtable }}
  134. NEED_CHARTCUTERIE: ${{ inputs.chartcuterie }}
  135. NEED_REDIS_CLUSTER: ${{ inputs.redis_cluster }}
  136. NEED_SYMBOLICATOR: ${{ inputs.symbolicator }}
  137. WORKDIR: ${{ inputs.workdir }}
  138. PG_VERSION: ${{ inputs.pg-version }}
  139. ENABLE_AUTORUN_MIGRATION_SEARCH_ISSUES: '1'
  140. run: |
  141. sentry init
  142. # redis, postgres are needed for almost every code path.
  143. services=(redis postgres)
  144. if [ "$NEED_CLICKHOUSE" = "true" ] || [ "$NEED_SNUBA" = "true" ]; then
  145. services+=(clickhouse)
  146. fi
  147. if [ "$NEED_SNUBA" = "true" ]; then
  148. services+=(snuba)
  149. fi
  150. if [ "$NEED_BIGTABLE" = "true" ]; then
  151. echo "BIGTABLE_EMULATOR_HOST=127.0.0.1:8086" >> $GITHUB_ENV
  152. services+=(bigtable)
  153. fi
  154. if [ "$NEED_CHARTCUTERIE" = "true" ]; then
  155. services+=(chartcuterie)
  156. fi
  157. if [ "$NEED_REDIS_CLUSTER" = "true" ]; then
  158. services+=(redis-cluster)
  159. fi
  160. if [ "$NEED_SYMBOLICATOR" = "true" ]; then
  161. services+=(symbolicator)
  162. fi
  163. if [ "$NEED_KAFKA" = "true" ]; then
  164. services+=(kafka)
  165. fi
  166. sentry devservices up "${services[@]}"
  167. # have tests listen on the docker gateway ip so loopback can occur
  168. echo "DJANGO_LIVE_TEST_SERVER_ADDRESS=$(docker network inspect bridge --format='{{(index .IPAM.Config 0).Gateway}}')" >> "$GITHUB_ENV"
  169. docker ps -a
  170. # This is necessary when other repositories (e.g. relay) want to take advantage of this workflow
  171. # without needing to fork it. The path needed is the one where tools are located
  172. cd "$WORKDIR"